#ifndef _Included_hashtbl_h
#define _Included_hashtbl_h

//-----------------------------------------------------------------------
//
//	Project TibThob: a tool to search the Rangjung Yeshe Dictionary
//
//
//	This program is subject to the GNU GENERAL PUBLIC LICENSE
//	It is provided as is - WITHOUT ANY WARRANTY - in the hope
//	it will be of benefit to all beings, or at least some of them.
//	
//-----------------------------------------------------------------------
//	Copyright Xavier C. FRANC 1999
//	report bugs and comments at:
//		xfranc@dial.oleane.com , xfra@balise.com
//
//-----------------------------------------------------------------------

#ifndef _Included_tibbasic_h
#include "tibbasic.h"
#endif

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//	class HashTable : a simple hash table for strings
//

class	HashTable
{
// .......... public methods ..................................
public:
	// create a table for 'size' entries (just a hint)
	HashTable(int size = 10);
	~HashTable();

	void	*find (const char *string, int length = -1);
	void	*find (int hash, const char *string, int length = -1);

	void	insert (void *data, const char *string, int length = -1);
	void	insert (void *data, int hash, const char *string, int length = -1);

	// standard string hashing:
static	int	hash (const char *str, int length);

// .......... instance variables ..............................
protected:
	struct Link {
		Link	*next;
		char	*key;
		void	*assoc;
	};

	int	size_;
	Link	**arena_;
}; // end of class HashTable

#endif
// DO NOT INSERT after this #endif 
