//-----------------------------------------------------------------------
//
//	Project TibThob: a tool to search the Rangjung Yeshe Dictionary
//
//
//	This program is subject to the GNU GENERAL PUBLIC LICENSE
//	It is provided as is - WITHOUT ANY WARRANTY - in the hope
//	it will be of benefit to all beings, or at least some of them.
//	
//-----------------------------------------------------------------------
//	Copyright Xavier C. FRANC 1999
//	report bugs and comments at:
//		xfranc@dial.oleane.com , xfra@balise.com
//
//-----------------------------------------------------------------------

#include "wylieapp.h"
#include "hashtbl.h"

TStatus	WylieReducer::loadTable (const char *path)
{
	FILE *input = fopen(path, "r");
	if (input == nil)
		return "cannot open";

	const int LINESIZE = 199;
	char  line[LINESIZE+1], word[100];
	int left = true;

	for( ; fgets(line, LINESIZE, input); ) {
		if (line[0] == '#')
			continue;
		if (line[0] == '%') {
			if (strncmp(line, "%left", 5) == 0)
				left = true;
			else if (strncmp(line, "%right", 6) == 0)
				left = false;
			else return "bad area";
			continue;
		}
		// an entry
		size_t L = strcspn(line, " =\t\r\n");	// blank is not significant
		memcpy(word, line, L); word[L] = 0;
		size_t S = L + strspn(line + L, "= \t\r\n");
		size_t EL = strcspn(line + S, "# \t\r\n");
		char *eq = (char*) malloc(EL + 1);
		memcpy(eq, line + S, EL);
		eq[EL] = 0;
		if (left)
			leftAssoc(word, eq);
		else {
			rightAssoc(word, eq);
		}
	}
	fclose(input);
	return nil;
}

WylieReducer::WylieReducer()
{
}

int	WylieReducer::convert (char equiv[])
{
	char *left = (char*) getLeft();
	if (left == nil)
		return -1;
	int L = strlen(left);
	memcpy(equiv, left, L);
	equiv[L++] = getVowel();
	char *right = (char*) getRight();
	if (right == nil) {
		// just copy the right part
		memcpy(equiv + L, wylie_ + leftSize_ + 1, rightSize_); 
		L += rightSize_;
	}
	else {
		strcpy(equiv + L, right);
		L += strlen(right);
	}
	equiv[L] = ' ';
	return L+1;
}
