#ifndef _Included_wylphon_h
#define _Included_wylphon_h

//-----------------------------------------------------------------------
//
//	Project TibThob: a tool to search the Rangjung Yeshe Dictionary
//
//
//	This program is subject to the GNU GENERAL PUBLIC LICENSE
//	It is provided as is - WITHOUT ANY WARRANTY - in the hope
//	it will be of benefit to all beings, or at least some of them.
//	
//-----------------------------------------------------------------------
//	Copyright Xavier C. FRANC 1999
//	report bugs and comments at:
//		xfranc@dial.oleane.com , xfra@balise.com
//
//-----------------------------------------------------------------------

#include "wylipars.h"

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//	class Wylie2Phonetics : converts Wylie to phonetics
//

class	Wylie2Phonetics : public WylieParser
{
// .......... public methods ..................................
public:
	Wylie2Phonetics();
	~Wylie2Phonetics();

	// called after parse(): returns a string of phonetic symbols
	// (see tibphon.h) and its length.
virtual	int	convert (char phonetics[]);

	// parse a table specifying the left parts, the vowel/suffix combinations,
	// and a table of special vowels:
virtual	TStatus	loadTable (const char *path);

	int	isOK()
		{ return leftTable_ != nil && inputTbl_ != nil; }

	// converts phonetic input to internal phonemes according to the
	// %input section of the table
	int	input2Phonemes (const char *input, char phonemes[]);

protected:
	// redefined lookup for right part: we take in account the vowel
virtual	void	*getRight (char *buffer = nil);

// .......... instance variables ..............................
protected:
	HashTable   *inputTbl_;

}; // end of class Wylie2Phonetics


#endif
// DO NOT INSERT after this #endif 
